import { defineStore } from "pinia";
import { ref, } from "vue";
import { useCounterMixin } from "@/stores/mixin";

const mixin = useCounterMixin();
const {
  date2Thai,
} = mixin;

export const useBrrowDataStore = defineStore("insigniaBrrow", () => {
  const insignia = ref<string>('')
  const insigniaOp = ref<any[]>([{ name: "ทั้งหมด", id: "", type: "" }])
  const insigniaType = ref<any>()
  const rows = ref<any>([])
  const listInsignia = ref<any>([])
  const employeeClass = ref<string>("all");
  const employeeClassOps = ref<any>([{ name: "ทั้งหมด", id: "all" }, { name: "ข้าราชการ กทม.สามัญ", id: "officer" }, { name: "ลูกจ้างประจำ", id: "perm" }])

  const fetchDataInsignia = async (data: any) => {
    insignia.value = ''
    insigniaOp.value = [{ name: "ทั้งหมด", id: "", type: "" }]
    data.forEach((e: any) => {
      insigniaOp.value.push({ name: e.name, id: e.id, type: e.insigniaType.id })
    });
  }
  const fetchDatainsigniaType = async (data: any) => {
    insigniaType.value = data.map((e: any) => ({ name: e.id, label: e.name }))
  }

  const fetchlistinsignia = async (data: any) => {
    rows.value = [];
    let list = await data.map((e: any) => ({
      id: e.id,
      citizenId: e.citizenId,
      prefix: e.prefix,
      position: e.position,
      status: status(e.status),
      name: e.fullName,
      type: e.requestInsignia,
      requestInsigniaId: e.requestInsigniaId,
      employeeType: profileType(e.profileType),
      profileType: e.profileType,
      dateReceive: date2Thai(e.dateReceive),
      date: date2Thai(e.date),
      volumeNo: e.volumeNo,
      section: e.section,
      page: e.page,
      number: e.no,
      vatnumber: e.number,
      datepay: date2Thai(e.datePayment),
      typepay: e.typePayment,
      address: e.address,
      borrowOrganization: e.borrowOrganization,
      borrowDate: e.borrowDate !== null ? date2Thai(e.borrowDate) : '-',
      returnOrganization: e.returnOrganization,
      returnDate: e.returnDate !== null ? date2Thai(e.returnDate) : '-',
      returnReason: e.returnReason !== null ? e.returnReason : '-',
    }));
    rows.value = list
    listInsignia.value = list
    console.log(listInsignia.value);

    searchDatatable(insignia.value, employeeClass.value)
  }
  const searchDatatable = (type: string, employeeClass: string) => {
    if (type !== '' && employeeClass !== "all") {
      rows.value = listInsignia.value.filter((e: any) => e.requestInsigniaId == type && e.profileType == employeeClass
      )
    } else if (type !== '' && employeeClass == "all") {
      rows.value = listInsignia.value.filter((e: any) => e.requestInsigniaId == type
      )
    } else if (type == '' && employeeClass !== "all") {
      rows.value = listInsignia.value.filter((e: any) => e.profileType == employeeClass
      )
    } else if (type === '' && employeeClass === "all") {
      rows.value = listInsignia.value
    }

  }

  const status = (val: string) => {
    switch (val) {
      case "PENDING":
        return "รอบันทึกข้อมูล";
      case "REJECT":
        return "ยกเลิก";
      case "DELETE":
        return "ลบ";
      case "DONE":
        return "บันทึกลง ก.พ. 7 แล้ว";
    }
  }
  const profileType = (val: string) => {
    switch (val) {
      case "officer":
        return "ข้าราชการ กทม.สามัญ";
      case "employee":
        return "ลูกจ้างประจำ";
    }
  }
  return {
    rows,
    listInsignia,
    insignia,
    insigniaOp,
    insigniaType,
    employeeClass,
    employeeClassOps,
    fetchDatainsigniaType,
    fetchDataInsignia,
    profileType,
    fetchlistinsignia,
    searchDatatable,
  };
});
